#include <WindowsConstants.au3>
#include <GUIConstants.au3>
#include <ButtonConstants.au3>
#include <File.au3>
Opt("WinTitleMatchMode",2)
Opt("GUIOnEventMode",1)

#Region Global
Global $FILE="",$PLAY=False,$TITLE="MonoPlayer"
#EndRegion Global

#Region GUI
$Form = GUICreate("MonoPlayer", 400, 100, 343, 288)
$MenuDatei = GUICtrlCreateMenu("Datei")
$MenuItemOpen = GUICtrlCreateMenuItem("ffnen" & @TAB & "Strg+O", $MenuDatei)
$MenuItemClose = GUICtrlCreateMenuItem("Schlieen" & @TAB & "Alt+F4", $MenuDatei)
$MenuHelp = GUICtrlCreateMenu("?")
$MenuItemInfo = GUICtrlCreateMenuItem("&Info", $MenuHelp)
$ButtonPlay = GUICtrlCreateButton(">", 8, 8, 49, 49, $WS_GROUP)
$Progress = GUICtrlCreateProgress(63, 16, 330, 33)
$LabelInfo = GUICtrlCreateLabel("keine Datei ausgewhlt", 8, 64, 392, 17)
#EndRegion GUI

#Region Set
Dim $accel[1][2]=[["^o",$MenuItemOpen]]
GUISetAccelerators($accel)
GUISetState()
#EndRegion Set
GUISetOnEvent($GUI_EVENT_CLOSE,"x")
GUICtrlSetOnEvent($MenuItemClose,"x")
GUICtrlSetOnEvent($MenuItemOpen,"_open")
GUICtrlSetOnEvent($ButtonPlay,"_play")
GUICtrlSetOnEvent($MenuItemInfo,"_Info")

#Region Main Loop
While Sleep(50)
WEnd
#EndRegion Main Loop

#Region Funcs
Func _play($ignore="")
	Local $lines,$curTime=0
	If not FileExists($FILE) THen Return _play(_open())
	$PLAY=True
	$time=_CountTime($FILE)
	_FileReadToArray($FILE, $lines)
	For $i=1 To $lines[0]
		$temp=StringSplit($lines[$i]," ")
		$curTime+=$temp[2]
		GUICtrlSetData($Progress,100*$curTime/$time)
		Beep($temp[1],$temp[2])
		If not $PLAY Then Return
	Next
	$PLAY=False
EndFunc
Func _open()
	$temp=FileOpenDialog("Beep-Datei ffnen",@WorkingDir,"Beep-Dateien (*.beep)|Alle Dateien (*.*)",3,"")
	If not @error Then
		$FILE=$temp
		$temp=StringSplit($FILE,"\")
		If not IsArray($temp) Then Exit msgBox(16,"Fehler","Schwerwiegender Ausnahmefehler!")
		WinSetTitle($TITLE,"","Monoplayer - " & $temp[$temp[0]])
		$TITLE="Monoplayer - " & $temp[$temp[0]]
		GUICtrlSetData($LabelInfo,$FILE)
	EndIf
EndFunc
Func _CountTime($FILE)
	Local $time,$lines
	_FileReadToArray($FILE, $lines)
	For $i=1 To $lines[0]
		$temp=StringSplit($lines[$i]," ")
		$time+=$temp[2]
	Next
	Return $time
EndFunc
func m($text) ;~ Die hab ich immer drin, damit Debuggen einfacher geht.
	MsgBox(0,"",$text)
EndFunc
func x()
	Exit
EndFunc
func _info()
	If MsgBox(64+4,"Info","MonoPlayer in seiner finalen Version, programmiert fr den Multimedia-wettbewerb von AutoIt.de." & @CRLF & @CRLF & "Das war sooo wenig Arbeit, das steht unter public domain (kann man mit machen, was man will)." & @CRLF  & @CRLF & "Der Wettbewerb findet sich hier: http://autoit.de/index.php?page=Thread&threadID=19564"  & @CRLF & @CRLF & @CRLF & "Den Thread jetzt besuchen?") = 6 Then ShellExecute("http://autoit.de/index.php?page=Thread&threadID=19564")
EndFunc
#EndRegion Funcs